(in-package :oou)
(oou-provide :ICON-di)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ICON-di.Lisp
;;
;; Copyright  1992 Northwestern University Institute for the Learning Sciences
;; All Rights Reserved
;;
;; author: Michael S. Engber
;;
;; ICON and ICON-button dialog items
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(oou-dependencies
 :graphic-rsrc-svm
 :disable-dim
 :button-dim)

(export '(ICON-di ICON-button-di set-view-ICON))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
(defclass ICON-di (graphic-rsrc-svm dialog-item)
  ((rsrc-id         :initarg :ICON-id)
   (rsrc-name       :initarg :ICON-name)
   (rsrc-handle     :initarg :ICON-handle)
   (graphic-scaling :initarg :ICON-scaling))
  (:default-initargs
    :rsrc-type "ICON"
    ))

(defclass ICON-button-di (disable-dim button-dim ICON-di) ())

(defmethod rsrc-get-fn ((di ICON-di) rsrc-type rsrc-id-or-name)
  (declare (ignore rsrc-type))
  (etypecase rsrc-id-or-name
    (fixnum (#_GetIcon rsrc-id-or-name))
    (string (#_GetIcon (get-resource-id "ICON" rsrc-id-or-name)))))

(defmethod graphic-size ((di ICON-di) ICON-handle)
  (declare (ignore di ICON-handle))
  #@(32 32))

(defmethod draw-graphic ((di ICON-di) ICON-handle rect)
  (#_PlotIcon rect ICON-handle))

(defmethod set-view-ICON ((di ICON-di) &key ICON-id ICON-name ICON-handle)
  (set-view-resource di :rsrc-id ICON-id :rsrc-name ICON-name :rsrc-handle ICON-handle))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|

(open-res-file "oou:examples;examples.rsrc")

(setf *test-w*
      (make-instance 'dialog
        :window-type :document
        :color-p t
        :view-position :centered
        :view-size #@(150 50)
        :window-title "ICON demo"
        :view-subviews (list (make-instance 'ICON-button-di
                               :view-position #@(59 10)
                               :ICON-name "executioner"
                               :dialog-item-action #'(lambda (item) (declare (ignore item)) (ed-beep))
                               :view-nick-name :cicn
                               ))))
 
|#